
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在附件管理模块中增加对FTP 上传和预览的支持 / iVAN</title>

    <meta name="description" content="在附件管理模块中增加对FTP 上传和预览的支持 在之前介绍的附件管理模块里面&lt;Winform开发框架之通用附件管理模块&gt;以及&lt;Winform开发框架之附件管理应用&gt;,介绍了附件的管理功能,通过对数据库记录的处理和文件的管理,实现了附件文件和记录的整合管理,可以运用在单机版的WInform框架,也可以使用在分布式的混合式开发框架中,随着一些开发场景的丰富,我们需要以FTP方式上传文件,因此对这个附件管理模块进行扩展,以便适合更多的实际项目需求. 1.FTP上传.HTTP文件预览实现思路 我们设想的附件管理,底层都是需要在 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">在附件管理模块中增加对FTP 上传和预览的支持</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在之前介绍的附件管理模块里面《<a href="http://wuhuacong.cnblogs.com/archive/2012/12/10/2812014.html" rel="external nofollow noreferrer">Winform开发框架之通用附件管理模块</a>》以及《<a href="http://wuhuacong.cnblogs.com/p/3360997.html" rel="external nofollow noreferrer">Winform开发框架之附件管理应用</a>》，介绍了附件的管理功能，通过对数据库记录的处理和文件的管理，实现了附件文件和记录的整合管理，可以运用在单机版的WInform框架，也可以使用在分布式的混合式开发框架中，随着一些开发场景的丰富，我们需要以FTP方式上传文件，因此对这个附件管理模块进行扩展，以便适合更多的实际项目需求。</p>
<h3>1、FTP上传、HTTP文件预览实现思路</h3>
<p>我们设想的附件管理，底层都是需要在Winform、Web等开发项目上重用的，因此底层的设计需要考虑好对应的处理，另外后面可以利用WInform的HTML编辑控件、或者Web的HTML编辑控件进行集成，附件则是统一在一个组件里面实现的。</p>
<p>借助FTP的文件上传，我们单机版本或者基于局域网的Winform界面程序，也可以单独构建一个FTP服务器，实现文件的共享；而分布式的混合式开发框架中，对于文件的上传，可以选择基于服务的文件系统写入，同时也可以基于FTP的方式上传。</p>
<p>基于混合式框架的FTP方式上传文件，其逻辑关系如下所示。</p>
<p> <img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzg4NjcvMjAxNzA2Lzg4NjctMjAxNzA2MDcxMjUyMzc3MDAtMjk4MTkyNjQzLnBuZw==.jpg"></p>
<p>这样文件通过FTP方式上传的文件系统后，我们在文件系统里面搭建一个HTTP服务，这样对应上的HTTP地址就可以实现文件的下载，以及图片的查看等操作了（可以在HTML编辑器中实现）。</p>
<h3>2、引入FTP组件实现文件上传</h3>
<p> 使用FTP上传，虽然在自己的公用类库里面有FTPHelper类可以使用，不过相对来说，我更愿意引入更为完善强大的FTP开源组件进行相关的处理，这里我们使用FluentFTP这个组件（GitHub地址：<a href="https://github.com/hgupta9/FluentFTP" rel="external nofollow noreferrer">https://github.com/hgupta9/FluentFTP</a> ），这个是一个应用很广，功能很强大的FTP组件。</p>
<p>FluentFTP是一款老外开发的基于.Net的支持FTP及的FTPS 的FTP类库，FluentFTP是完全托管的FTP客户端，被设计为易于使用和易于扩展。它支持文件和目录列表，上传和下载文件和SSL / TLS连接。它可以连接到Unix和Windows IIS建立FTP服务器。这个项目是完全开发托管C #。</p>
<p>这个组件的使用代码，这里粘贴一下，以便总体有一个直观的了解吧。</p>
<pre>// create an FTP client
FtpClient client = new FtpClient("123.123.123.123");

// if you don't specify login credentials, we use the "anonymous" user account
client.Credentials = new NetworkCredential("david", "pass123");

// begin connecting to the server
client.Connect();

// get a list of files and directories in the "/htdocs" folder
foreach (FtpListItem item in client.GetListing("/htdocs")) {

    // if this is a file
    if (item.Type == FtpFileSystemObjectType.File){

        // get the file size
        long size = client.GetFileSize(item.FullName);

    }

    // get modified date/time of the file or folder
    DateTime time = client.GetModifiedTime(item.FullName);

    // calculate a hash for the file on the server side (default algorithm)
    FtpHash hash = client.GetHash(item.FullName);

}

// upload a file
client.UploadFile(@"C:\MyVideo.mp4", "/htdocs/big.txt");

// rename the uploaded file
client.Rename("/htdocs/big.txt", "/htdocs/big2.txt");

// download the file again
client.DownloadFile(@"C:\MyVideo_2.mp4", "/htdocs/big2.txt");

// delete the file
client.DeleteFile("/htdocs/big2.txt");

// delete a folder recursively
client.DeleteDirectory("/htdocs/extras/");

// check if a file exists
if (client.FileExists("/htdocs/big2.txt")){ }

// check if a folder exists
if (client.DirectoryExists("/htdocs/extras/")){ }

// upload a file and retry 3 times before giving up
client.RetryAttempts = 3;
client.UploadFile(@"C:\MyVideo.mp4", "/htdocs/big.txt", FtpExists.Overwrite, false, FtpVerify.Retry);

// disconnect! good bye!
client.Disconnect();</pre>
<p>有了这些了解，我们在普通Winform程序或者混合式框架的的程序中，我们通过配置指定FTP的相关信息，就可以在代码里面加载这些信息，进行FTP的登陆、文件上传、下载等操作了。</p>
<h3>3、附件管理模块实现</h3>
<p>有了上面的思路和组件的辅助，我们对原来的附件管理模块进行相关的升级处理即可实现FTP上传模式的处理了。</p>
<p>首先为了方便，我们先定义一个获取FTP服务器、用户名、密码等参数的配置实体类，如下所示。</p>
<pre>    /// &lt;summary&gt;
    /// FTP配置信息
    /// &lt;/summary&gt;
    [DataContract]
    [Serializable]
    public class FTPInfo
    {
        /// &lt;summary&gt;
        /// 默认构造函数
        /// &lt;/summary&gt;
        public FTPInfo()
        {

        }

        /// &lt;summary&gt;
        /// 参数化构造函数
        /// &lt;/summary&gt;
        /// &lt;param name="server"&gt;&lt;/param&gt;
        /// &lt;param name="user"&gt;&lt;/param&gt;
        /// &lt;param name="password"&gt;&lt;/param&gt;
        public FTPInfo(string server, string user, string password, string baseUrl)
        {
            this.Server = server;
            this.User = user;
            this.Password = password;
            this.BaseUrl = baseUrl;
        }

        /// &lt;summary&gt;
        /// FTP服务地址
        /// &lt;/summary&gt;
        [DataMember]
        public string Server { get; set; }

        /// &lt;summary&gt;
        /// FTP用户名
        /// &lt;/summary&gt;
        [DataMember]
        public string User { get; set; }

        /// &lt;summary&gt;
        /// FTP密码
        /// &lt;/summary&gt;
        [DataMember]
        public string Password { get; set; }

        /// &lt;summary&gt;
        /// FTP的基础路径，如可以指定为IIS的路径：http://www.iqidi.com:8000 ,方便下载打开
        /// &lt;/summary&gt;
        [DataMember]
        public string BaseUrl { get; set; }
    }</pre>
<p>定义一个函数，专门用来提取配置文件里面的相关FTP参数的，如下所示。</p>
<pre>        /// &lt;summary&gt;
        /// 获取配置的FTP配置参数
        /// &lt;/summary&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        private FTPInfo GetFTPConfig()
        {
            var ftp_server = config.AppConfigGet("ftp_server");
            var ftp_user = config.AppConfigGet("ftp_user");
            var ftp_pass = config.AppConfigGet("ftp_password");
            var ftp_baseurl = config.AppConfigGet("ftp_baseurl");

            return new FTPInfo(ftp_server, ftp_user, ftp_pass, ftp_baseurl);
        }</pre>
<p>其中我们的配置文件如下所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzg4NjcvMjAxNzA2Lzg4NjctMjAxNzA2MDcxMzU0MzQ3OTMtMTk4NzA3Mjk0Ny5wbmc=.jpg"></p>
<p>使用FluentFTP的组件代码如下所示。</p>
<pre>//使用FluentFTP操作FTP文件
FtpClient client = new FtpClient(ftpInfo.Server, ftpInfo.User, ftpInfo.Password);</pre>
<p>然后调用FTP组件对目录进行判断，无则创建一个即可。</p>
<pre>//确定日期时间目录（格式：yyyy-MM），不存在则创建
string savePath = string.Format("/{0}-{1:D2}/{2}", DateTime.Now.Year, DateTime.Now.Month, category);
bool isExistDir = client.DirectoryExists(savePath);
if(!isExistDir)
{
    client.CreateDirectory(savePath);
}</pre>
<p>最后使用组件上传文件即可，这里上传文件，由于前面FileUploadInfo实体类里面存储的是字节数组，因此也是采用FTP组件直接上传字节数组即可。</p>
<pre>//使用FTP上传文件
//避免文件重复，使用GUID命名
var ext = FileUtil.GetExtension(info.FileName);
var newFileName = string.Format("{0}{1}", Guid.NewGuid().ToString(), ext);//FileUtil.GetFileName(file);

savePath = savePath.UriCombine(newFileName);
bool uploaded = client.Upload(info.FileData, savePath, FtpExists.Overwrite, true);</pre>
<p>文件上传到文件服务器后，剩下的就是把相关的信息存储到附件管理模块的数据表里面即可，这样可以在使用的时候，直接使用数据库里面的信息，如果是需要查看图片或者下载文件，那么拼接好相关的HTTP地址即可，我们来看看对应的数据库记录截图如下所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzg4NjcvMjAxNzA2Lzg4NjctMjAxNzA2MDcxNDExNDczNzItMTc2ODc3ODg3NS5wbmc=.jpg"></p>
<p>有了这些基础信息，我们可以同时改造我之前介绍过的Winform之HTML编辑控件：ZetaHtmlEditControl了（<a href="http://wuhuacong.cnblogs.com/p/3520246.html" rel="external nofollow noreferrer">分享一个Winform里面的HTML编辑控件Zeta HTML Edit Control，汉化附源码</a>），我对这个控件所有英文的菜单、工具栏、对话框、提示内容等资源进行中文化后，并在工具栏中增加插入图片、打印功能后，界面如下所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzg4NjcvMjAxNDAxLzE1MDkzNDA2MDgwNi5wbmc=.jpg"></p>
<p>默认情况下，我们加入图片的方式，肯定还是基于本地文件的方式了；但是经过我们改造使用FTP上传文件方式后，在控件上获得HTTP地址，就可以对图片文件进行预览展示的操作了。</p>
<p>这种方法构造的图片地址，属于标准的URL地址，可以在各个地方进行查看的，如下界面所示。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzg4NjcvMjAxNzA2Lzg4NjctMjAxNzA2MDcxNDIzMjA5OTctOTgyMTU5ODE1LnBuZw==.jpg"></p>
<p>这个就是ZetaHtmlEditControl控件，整合我们前面已经完成了FTP上传模式的附件管理模块，实现编辑在线HTML的功能，这样的HTML内容，同样可以适合在Web界面下的HTML编辑器上进行展示了。</p>
<p>以上就是我为整个WInform开发框架构造的项目组件，增加的FTP上传方式，同时完善了对应的场景需求，在ZetaHtmlEditControl控件上实现编辑在线HTML的功能，希望开发的思路对您有所增益。</p>
<p>本文转自博客园伍华聪的博客，原文链接：<a href="http://www.cnblogs.com/wuhuacong/p/6956419.html" rel="external nofollow noreferrer">在附件管理模块中增加对FTP 上传和预览的支持</a>，如需转载请自行联系原博主。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 17:56:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%a8%a1%e5%9d%97/" title="模块">模块</a>, <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/server/" title="server">server</a>, <a href="https://www.iamivan.net/tag/ftp/" title="ftp">ftp</a>, <a href="https://www.iamivan.net/tag/file/" title="file">file</a>, <a href="https://www.iamivan.net/tag/string/" title="string">string</a>, <a href="https://www.iamivan.net/tag/html/" title="html">html</a>, <a href="https://www.iamivan.net/tag/%e5%bc%80%e5%8f%91%e6%a1%86%e6%9e%b6/" title="开发框架">开发框架</a>, <a href="https://www.iamivan.net/tag/htdocs/" title="htdocs">htdocs</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>在附件管理模块中增加对FTP 上传和预览的支持的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPkymZM.html" rel="bookmark">我用的是pb6&period;5开发环境，不知道用什么功能或控件能实现附件上传及预览功能呢？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我用的是pb6.5开发环境,不知道用什么功能或控件能实现附件上传及预览功能呢? 我有一个专门放附件的目录,想通过listbox来显示文件列表,点击任何一个内容,能将文件的内容显示到指定的地方 解决方案 http://blog.163.com/ljian@126/blog/static/117523337201431131640540/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pd7Oe6M.html" rel="bookmark">php中如何实现ftp上传基础代码</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  ftp工具我们都用过是用来上传文件的,那么在php中如何用代码实现呢,下面简单介绍一个最基础最简单的列子,首先根据我们使用ftp工具来说,实现文件上传需要打开ftp工具-&gt;输入ftp地址,端口号,账号,密码登陆ftp-&gt;从本地选择相应文件上传到ftp相应目录,php中要实现这么一个简单的功能无非也是这样. 第一步:打开ftp $ip=&quot;101.101.101.101&quot;; $name=&quot;name&quot;; $pwd=&quot;mima&quot;; $co			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PoyBp.html" rel="bookmark">在asp&period;net中如何使用ftp上传2G以上大文件？？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如题 解决方案 解决方案二:没人知道吗?解决方案三:ftp解决方案四:http://www.cnblogs.com/lovecherry/archive/2005/10/13/253658.html解决方案五:这个方法我试过了.一上传就提示&quot;无法显示网页&quot;.解决方案六:你可以生成一个bat文件,让新起的进程去跑.bat文件里面就是ftp的一些上传信息.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKqOVWp.html" rel="bookmark">Android中FTP上传、下载的功能实现（含进度）&lowbar;Android</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 Android中使用的FTP上传.下载,含有进度. 代码部分主要分为三个文件:MainActivity,FTP,ProgressInputStream 1. MainActivity package com.ftp; import java.io.File; import java.io.IOException; import java.util.LinkedList; import com.ftp.FTP.DeleteFileProgressListener; import com.ftp.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zeaELwz.html" rel="bookmark">Android中FTP上传、下载的功能实现（含进度）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android中使用的FTP上传.下载,含有进度. 代码部分主要分为三个文件:MainActivity,FTP,ProgressInputStream 1. MainActivity package com.ftp; import java.io.File; import java.io.IOException; import java.util.LinkedList; import com.ftp.FTP.DeleteFileProgressListener; import com.ftp.F			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z76LA5p.html" rel="bookmark">Winform开发框架之通用附件管理模块</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在做Winform项目的时候,一直有一个梦想,就是希望把所有的组件模块组合即可组装成一个完整的项目系统(或者至少可以大部分完成).这即使是梦想,我也一直为之奋斗,每前进一步,我们离梦想就靠近一步.因此,本着这个梦想,我一路走来,开发整理了一系列的组件模块,包括底层的公用类库.Winform分页控件.通用的适应多数据库的查询组件,以及相对高层次一点的组件模块:通用权限管理系统.通用字典管理模块.通用程序自动更新模块.以及本篇随笔介绍的通用附件管理模块,当然还会有更多的组件模块会吸引我继续朝着梦想前			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/OMgAOOz.html" rel="bookmark">ERP基础档案管理模块中实现多级分类档案ID号自动编码技术&lpar;V1&period;0&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				erp|编码     ERP基础档案管理模块中实现多级分类档案ID号自动编码技术(V1.0)       本存储过程实现了多级分类档案ID号自动编码技术,本版本(V1.0)现在只实现每级3位的编码, 本版本的特点是: n          可以根据不同的数据库表产生不同的编码,达到通用化 n          调用时通过指定iIsSubNode要产生的节点编码是否是子结点还是兄弟节点来生成对应编码 进行调用本存储过程时需要注意的是需要传递节点的层次(或是叫节点的深度) 另外下一个版本(V2.0)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/qba1e2b.html" rel="bookmark">ERP基础档案管理模块中实现多级分类档案级联删除技术</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				erp ERP基础档案管理模块中实现多级分类档案级联删除技术   本存储过程实现了多级分类档案级联删除技术 本存储过程的特点是: n          可以在不同的数据库表上应用此存储过程,以达到通用化 n          同时用户也可以根据不同的表结构,选择相应版本的的存储过程,在这里共有三个版本可供用户选择,分别对应表结构中有无节点的深度字段等情况 进行调用本存储过程时只需要传递节点号及表名即可,但是用户选择相应版本进行应用时,需要针对实际情况作出选择 版本一 CREATE procedu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXq6LLz.html" rel="bookmark">进销存 库存-正在做进销存管理&comma;库存管理模块中&comma;货架信息除了增删改查之外还需要什么方法&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 正在做进销存管理,库存管理模块中,货架信息除了增删改查之外还需要什么方法? 正在做进销存管理,库存管理模块中,货架信息除了增删改查之外还需要什么方法? 解决方案 库存盘点,对库存进行人工审计之后与系统中的数量进行比对,可以发现是否存在不一致,或者发现库存中有货品损坏则,应该进行一个损益,进行金额的损益计算.同时将数据库中的库存数量进行更新.大概就这些吧,我自己之前也做过.如果还想做得更加详细的话,需要到超市进行实际的需求采集 解决方案二: 增删改查 这就已经包扩了所有,任何项目的模块也			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqO0Gz.html" rel="bookmark" class="title">jquery核心buildFragment</a>
					<div>
						核心buildFragment DOM原生的接口是即简单又单一,参数类型确定,也不会重载,每次只会处理一个元素.在看jQuery完全反其道而行之参数复杂多样,接口重载厉害.如果一次传递N多的节点元素那 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB03Op.html" rel="bookmark" class="title">几个很有用的javascript函数</a>
					<div>
						javascript|函数 函数Reset()按Reset按钮后对各字段的内容复位. 函数submitForms()按submit按钮后对字段合法性检查后发送电子邮件. 函数isName()对姓名字段 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1aW5M.html" rel="bookmark" class="title">你的宣传地盘在哪里，你的用户在哪里？</a>
					<div>
						推广很重要,有一句话说的非常好,无处不在推广.话虽至此,但是并不一定能有效果的.    推广你在非你的用户上推广,纯粹是浪费体力.记得曾经有一个激励故事是说,两个卖鞋的都到一个荒岛去卖鞋,一个回来禀报 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVZNmz.html" rel="bookmark" class="title">基于Jave的Web服务工作机制&lpar;2&rpar;</a>
					<div>
						HTTP响应(Responses)  和请求类似,一个HTTP响应也包含三个部分: 协议状态 代码描叙(Protocol-Status code-Description) 响应包头(Response  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMRAwdb.html" rel="bookmark" class="title">一篇关于客户端用ASP参生报表的好东东</a>
					<div>
						客户端 先贴一篇较简单的用ASP+RDS客户端参生报表 此文希望能进精华篇下一回贴一篇较复杂的说明:(若提示ActiveX 元件无法参生 RDS.DataSpace)IE需设置安全选项操作:菜单工具- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5B76z.html" rel="bookmark" class="title">SEO基础篇&colon; 案例分析404错误页面</a>
					<div>
						每当我们打开一网站时如果长时间没有反应时,或者URL错误时会看到下面这种情景:   这个错误页面就是404页面,今天上海SEO潇然孤雁飞就和大家聊一聊404这个家喻户晓的SEO基本知识. 404页面就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrO8Wp.html" rel="bookmark" class="title">网站SEO优化中&OpenCurlyDoubleQuote;内容为王&rdquo;必须遵循的四个原则</a>
					<div>
						做SEO的朋友,想必都知道,网站优化中,&quot;内容为王,外链为皇&quot;,这句话,初始学SEO,我们都会有一段迷茫的时期,我们认认真真的按SEO优化的方法,按SEO优化的技巧去优化我们的站, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4w54Pp.html" rel="bookmark" class="title">在Web Service中使用Windows验证的方式</a>
					<div>
						很多朋友都知道在Web Service中支持Windows验证.但其实能用好的朋友并不 是特别多,因为有几个特殊之处需要注意 1.在服务端如何配置 这里要注意的是,authentication的mod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPAqOM.html" rel="bookmark" class="title">Photoshop打造梦幻的蓝色仿手绘美女</a>
					<div>
						教程介绍较为综合的人物美化方法.这个需要较高的审美能力,需要把人物脸部及装饰等不太理想的部分尽量处理完美.其中包括脸型.发丝.五官等.整体美化后再调成自己喜欢的颜色即可. 最终效果 1.打开模特图片, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bal8enz.html" rel="bookmark" class="title">教你轻松修改PPT中剪贴画颜色</a>
					<div>
						在制作演示文稿时,为了达到满意的效果我们经常会插入漂亮的剪贴画.但有时起到的效果会相反,因为剪贴画是程序自带的组件,其颜色都是固定的,这样就可能与页面整体的效果不协调.   其实大家不必为其担心,借助 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7WLDb.html" rel="bookmark" class="title">Codeigniter通过SimpleXML将xml转换成对象的方法</a>
					<div>
						 这篇文章主要介绍了Codeigniter通过SimpleXML将xml转换成对象的方法,涉及Codeigniter操作XML文件的技巧,非常具有实用价值,需要的朋友可以参考下     本文实例讲述了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wlZJp.html" rel="bookmark" class="title">PS照片处理教程（二）：证件照换装</a>
					<div>
						自上周推出&quot;PS照片处理教程-证件照换底&quot;教程后收到很多网友的信息,主要问题集中在换白色背景及换装上,对此本周以&quot;证件照换装&quot;教程来解答,有需要的朋友可以看看! ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXXZ7p.html" rel="bookmark" class="title">win8&period;1打开IE浏览器提示&OpenCurlyDoubleQuote;IE为了保护计算机而关闭网页&rdquo;如何解决</a>
					<div>
						  win8.1操作系统自带IE浏览器,虽然现在网上有很多第三方软件,但是一些用户依旧在使用IE浏览器.最近有位雨林木风win8.1系统打开IE浏览器提示&quot;IE为了保护计算机而关闭网页&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZmEJz.html" rel="bookmark" class="title">Win7系统打开出现蓝屏代码0x00000f4怎么办&quest;</a>
					<div>
						  我在早上打开win7电脑的时候,电脑就出现蓝屏(如下图所示),并显示蓝屏代码0x00000f4,之后电脑也自动重启,请问蓝屏代码0x00000f4怎么办? 编辑回答:蓝屏代码0x00000F4可能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq81aGb.html" rel="bookmark" class="title">如何清理恶评插件</a>
					<div>
						  在我们实用电脑的过程中,难免会碰到一些恶评插件,这些恶评插件队我们计算机的正常实用有着很大的影响,甚至会导致系统瘫痪,我们要经常查看我们的电脑中是否有恶意插件,然后清理掉,保证我们计算机的正常使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBkP8z.html" rel="bookmark" class="title">字符 生成-简单的字符生成器-排列组合</a>
					<div>
						问题描述 简单的字符生成器-排列组合 想要实现以下图片上的功能,上方选中我需要用的字母.数字,输入我需要生成的位数,最终列出所有的排列组合数据.求人帮忙,万分感谢. 解决方案 关键就是算法http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywL2kz.html" rel="bookmark" class="title">link环境下，制作一款《订餐软件》，请问那种手持的订餐机的软件，怎么和主系统对接？</a>
					<div>
						问题描述 link环境下,制作一款&lt;订餐软件&gt;,请问那种手持的订餐机的软件,怎么和主系统对接? link环境下,制作一款&lt;订餐软件&gt;,请问那种手持的订餐机的软件,怎么和主系统对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6Alwb.html" rel="bookmark" class="title">第九章 关系映射 继承关联映射</a>
					<div>
						1.discriminator鉴别器 同一张表中表示不同的类型 在employee表中定义一个type字段,表示员工的类型 name是所有的员工都有的属性. sale_count是销售员特有的属性.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAlDGM.html" rel="bookmark" class="title">dns-bind有版本A记录支持权重吗？</a>
					<div>
						问题描述 bind有版本A记录支持权重吗? 看见过有家dns服务商配置A记录时,支持权重,不知道怎么实现? bind有版本支持吗? 解决方案 bind不支持权重 在实际使用中我们会发现,BIND的轮训 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlQ3rOp.html" rel="bookmark" class="title">递归-C语言：给定一个数组，求和为定值的组合的个数（不限组合内的数字个数）怎么解决？</a>
					<div>
						问题描述 C语言:给定一个数组,求和为定值的组合的个数(不限组合内的数字个数)怎么解决? 问题在于只用C语言,递归和回溯都不太懂,希望给个大概的思路,初学语言,谢谢了! 解决方案 最简单的就是递归,可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL78XZM.html" rel="bookmark" class="title">VB 6&period;0关于在菜单控件中添加一个超级链接的问题</a>
					<div>
						问题描述 VB 6.0关于在菜单控件中添加一个超级链接的问题 在VB 6.0编程系统中怎么在主菜单条控件上增加一个超级链接,点超级链接就打开公司的购买网站页面? 解决方案 可以把超链接放在coolba ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEW1kM.html" rel="bookmark" class="title">《第三方电子商务交易平台服务规范》</a>
					<div>
						第一财讯:商务部发布文件规范第三方电子商务交易平台的经营活动,鼓励平台经营者设立冷静期制度,允许消费者在冷静期内无理由取消订单. 这份名为&lt;第三方电子商务交易平台服务规范&gt;的文件指出,要求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmXX6b.html" rel="bookmark" class="title">染整业ERP软件管理系统-出售</a>
					<div>
						问题描述 染整业ERP软件管理系统简介如需更多信息请联系徐丰15902134313QQ:33375354MSN:twtdh@hotmail.come-mail:[email=twtdh@163.com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAA3nJM.html" rel="bookmark" class="title">谷歌地图API添加形状</a>
					<div>
						简介 您可以向地图添加各种形状.形状是地图上与某个纬度/经度坐标绑定的对象.可用的形状如下:线.多边形.圆和矩形.您还可以将形状配置为可供用户进行编辑或拖动. 多段线 如需在地图上绘制线,请使用多段线 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYw3Op.html" rel="bookmark" class="title">asp&period;net-net&comma;vs学生管理系统sql2005&comma;有可用源码与数据库说明&comma;只需连接打开&comma;帮我录个演示视频</a>
					<div>
						问题描述 net,vs学生管理系统sql2005,有可用源码与数据库说明,只需连接打开,帮我录个演示视频 因毕设急需演示视频,本人sqlserver无法连接上,急需吧友根据我的可用源码打开程序连接数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Z5g6z.html" rel="bookmark" class="title">《实践者的研究方法》&mdash;&mdash; 第2章 软件工程 2&period;4 软件开发神话</a>
					<div>
						2.4 软件开发神话 软件开发神话,即关于软件及其开发过程的一些被人盲目相信的说法,这可以追溯到计算技术发展的初期.神话具有一些特点,让人觉得不可捉摸.例如,神话看起来是事实的合理描述(有时的确包含真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyerZ5M.html" rel="bookmark" class="title">entity bean不能够在jboss中部署</a>
					<div>
						问题描述 我使用eclipse学习实体bean的开发,按照书上一步一步的来的,没有错误,可是就是不能实现部署,想请教一下什么原因?1.persistence.xml[code=XM]&lt;?xmlv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg4ZAM.html" rel="bookmark" class="title">微服务和容器对企业带来什么样的影响&quest;</a>
					<div>
						IT经理.架构师和开发者都尝试妥协于微服务和容器对企业IT方式的改变.在某一个层面来说这是一件好事,但是事实上,一些更深层次的东西在驱动着技术和IT. 要理解微服务和容器,可以从抓住它的价值定义开始, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JvOWz.html" rel="bookmark" class="title">简单来说，我们常听到的 22nm、14nm、10nm 究竟是什么意思？</a>
					<div>
						如题,先从大厂说起.目前芯片厂商有三类:IDM.Fabless.Foundry. IDM(集成器件制造商)指 Intel.IBM.三星这种拥有自己的晶圆厂,集芯片设计.制造.封装.测试.投向消费者市场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZBlgwz.html" rel="bookmark" class="title">任正非一夜之间成&OpenCurlyDoubleQuote;网红&rdquo;，原因可不只是在机场等出租这么简单</a>
					<div>
						周六下午,我和朋友周先生约在虹桥天地谈事,他周五晚上刚从深圳出差回到上海.谈话中周先生提到一件小事,他昨天晚上在虹桥机场等出租车时,看到一个人很像任正非,但他不太确定是不是他,于是就用手机拍了张照片. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
